--[[-----------------------------------------------------------------------------
 Olivier Cthun, RU Guild, LUMEN
 Based on: https://github.com/goffauxs/Salad_Cthun
-------------------------------------------------------------------------------]]

local dotPos = {
    [1] = { -29, 63 }, --melee        	--
    [2] = { -20, 69 }, --2nd melee   	-|
    [3] = { -54, 90 }, --ranged    		-|Group 1
    [4] = { -14, 106 }, --ranged     	-|
    [5] = { -45, 125 }, --healer        --

    [6] = { 24, 68 }, -- melee      	--
    [7] = { 35, 63 }, --2nd melee       -|
    [8] = { 21, 106 }, --ranged    		-|Group 2
    [9] = { 61, 90 }, --ranged    		-|
    [10] = { 52, 125 }, --healer        --

    [11] = { -60, 23 }, -- melee    	--
    [12] = { -54, 32 }, --2nd melee   	-|
    [13] = { -96, 22 }, --ranged  		-|Group 3
    [14] = { -80, 61 }, --ranged   		-|
    [15] = { -115, 52 }, --healer       --

    [16] = { 63, 33 }, -- melee    		--
    [17] = { 66, 23 }, --2nd melee   	-|
    [18] = { 87, 61 }, --ranged    		-|Group 4
    [19] = { 103, 22 }, --ranged   		-|
    [20] = { 122, 52 }, --healer        --

    [21] = { -50, -24 }, -- melee     	--
    [22] = { -55, -14 }, --2nd melee   	-|
    [23] = { -77, -52 }, --ranged  		-|Group 5
    [24] = { -94, -14 }, --ranged   	-|
    [25] = { -112, -46 }, --healer      --

    [26] = { 66, -18 }, -- melee    	--
    [27] = { 61, -28 }, --2nd melee   	-|
    [28] = { 102, -14 }, --ranged  		-|Group 6
    [29] = { 85, -52 }, --ranged  		-|
    [30] = { 119, -46 }, --healer       --

    [31] = { -16, -55 }, -- melee   	--
    [32] = { -26, -50 }, --2nd melee  	-|
    [33] = { -12, -92 }, --ranged 		-|Group 7
    [34] = { -51, -76 }, --ranged 	    -|
    [35] = { -41, -112 }, --healer      --

    [36] = { 33, -49 }, -- melee     	--
    [37] = { 23, -55 }, --2nd melee   	-|
    [38] = { 58, -76 }, --ranged   		-|Group 8
    [39] = { 19, -92 }, --ranged  		-|
    [40] = { 48, -112 } --healer        --
}

local CLASS_COLOR = {
    ["WARRIOR"] = { 0.68, 0.51, 0.33 },
    ["ROGUE"] = { 1.0, 0.96, 0.31 },
    ["MAGE"] = { 0.21, 0.60, 0.74 },
    ["WARLOCK"] = { 0.48, 0.41, 0.69 },
    ["HUNTER"] = { 0.47, 0.73, 0.25 },
    ["PRIEST"] = { 1.0, 1.00, 1.00 },
    ["PALADIN"] = { 0.96, 0.55, 0.73 },
    ["DRUID"] = { 1.0, 0.49, 0.04 },
    ["SHAMAN"] = { 0.0, 0.34, 0.77 }
}

local oliPlayerName, _ = UnitName("player")
local oliBackdrop = {
    bgFile = "Interface\\AddOns\\OlivierCthun\\Media\\oliPositions.tga",
    edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border",
    tile = false,
    edgeSize = 32,
    insets = {
        left = 12,
        right = 12,
        top = 12,
        bottom = 12
    }
}

local Olivier_Frame = CreateFrame("Frame", "Olivier_UI", UIParent)
Olivier_Frame:EnableMouse(true)
Olivier_Frame:SetMovable(true)
Olivier_Frame:SetHeight(534)
Olivier_Frame:SetWidth(534)
Olivier_Frame:SetPoint("CENTER", 0, 0)
Olivier_Frame:SetBackdrop(oliBackdrop)
Olivier_Frame:SetAlpha(1.00)
Olivier_Frame:SetUserPlaced(true)
Olivier_Frame:SetFrameStrata("HIGH")
Olivier_Frame:RegisterEvent("GROUP_ROSTER_UPDATE")
Olivier_Frame:SetScript("OnEvent", function()
    oliFill()
end)
Olivier_Frame:SetScript("OnMouseWheel", function()
    if (Olivier_Frame:GetScale() == 1) then
        Olivier_Frame:SetScale(0.5)
    else
        Olivier_Frame:SetScale(1)
    end
end)
Olivier_Frame:Hide()
tinsert(UISpecialFrames, 'Olivier_UI'); -- ESC

local Olivier_Header = CreateFrame("Frame", "Olivier_Header", Olivier_Frame)
Olivier_Header:SetPoint("TOP", Olivier_Frame, "TOP", 0, 12)
Olivier_Header:SetWidth(312)
Olivier_Header:SetHeight(64)
Olivier_Header:SetBackdrop({
    bgFile = "Interface\\DialogFrame\\UI-DialogBox-Header"
})

local Olivier_Drag = CreateFrame("Frame", nil, Olivier_Frame)
Olivier_Drag:SetWidth(256)
Olivier_Drag:SetHeight(64)
Olivier_Drag:SetPoint("TOP", Olivier_Frame, "TOP", 0, 12)
Olivier_Drag:EnableMouse(true)
Olivier_Drag:SetScript("OnMouseDown", function()
    Olivier_Frame:StartMoving()
end)
Olivier_Drag:SetScript("OnMouseUp", function()
    Olivier_Frame:StopMovingOrSizing()
end)
Olivier_Drag:SetScript("OnHide", function()
    Olivier_Frame:StopMovingOrSizing()
end)

local Olivier_Font = Olivier_Header:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
Olivier_Font:SetPoint("CENTER", Olivier_Header, "CENTER", 0, 12)
Olivier_Font:SetText("Оливьешка (К'Тун)")

local Olivier_Exit = CreateFrame("Button", "Olivier_Exit", Olivier_Frame)
Olivier_Exit:SetPoint("TOPRIGHT", Olivier_Frame, "TOPRIGHT", -5, -5)
Olivier_Exit:SetHeight(32)
Olivier_Exit:SetWidth(32)
Olivier_Exit:SetNormalTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Up")
Olivier_Exit:SetHighlightTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight")
Olivier_Exit:SetPushedTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Down")
Olivier_Exit:SetScript("OnLoad",
        function()
            Olivier_Exit:RegisterForClicks("AnyUp")
        end
)
Olivier_Exit:SetScript("OnClick",
        function()
            Olivier_Frame:Hide();
        end
)

--Create 40 dot frames
for i = 1, MAX_RAID_MEMBERS do
    dot = CreateFrame("Button", "Dot_" .. i, Olivier_Frame)
    dot:SetPoint("CENTER", Olivier_Frame, "CENTER", dotPos[i][1], dotPos[i][2])
    dot:EnableMouse(true)
    dot:SetFrameLevel(dot:GetFrameLevel() + 3)
    tooltip = CreateFrame("GameTooltip", "Tooltip_" .. i, nil, "GameTooltipTemplate")
    local texdot = dot:CreateTexture("Texture_" .. i, "OVERLAY")
    dot.texture = texdot
    texdot:SetAllPoints(dot)
    texdot:SetTexture("Interface\\AddOns\\OlivierCthun\\Media\\oliDot.tga")
    texdot:Hide()
    dot:SetScript("OnEnter", function()
        tooltip:SetOwner(dot, "ANCHOR_RIGHT")
        tooltip:SetText("Empty")
        tooltip:Show()
    end)
    dot:SetScript("OnLeave", function()
        tooltip:Hide()
    end)
end

local function newDot(dot, tooltip, texture, name, class)
    if (oliPlayerName == name) then
        dot:SetWidth(36)
        dot:SetHeight(36)
        dot:SetFrameLevel(1000) --on top melee fix
    else
        dot:SetWidth(20)
        dot:SetHeight(20)
    end

    if name ~= "Empty" then
        texture:SetVertexColor(CLASS_COLOR[class][1], CLASS_COLOR[class][2], CLASS_COLOR[class][3], 1.0)
        texture:Show()
    else
        texture:Hide()
    end

    dot:SetScript("OnEnter", function()
        tooltip:SetOwner(dot, "ANCHOR_RIGHT")
        tooltip:SetText(name)
        tooltip:Show()
    end)

    dot:SetScript("OnLeave", function()
        tooltip:Hide()
    end)
end

local dotRes = { { { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" } }, -- group 1
                 { { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" } }, -- group 2
                 { { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" } }, --    |
                 { { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" } }, --    |
                 { { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" } }, --    |
                 { { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" } }, --    |
                 { { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" } }, --    |
                 { { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" } } } -- group 8

function oliFakeRaidRosterInfo(index)
    if (index < 0) then
    elseif (index == 1) then
        return 'Fake' .. index, '', 1, '', '', 'WARRIOR'
    elseif (index == 2) then
        return 'Fake' .. index, '', 1, '', '', 'ROGUE'
    elseif (index == 3) then
        return 'Fake' .. index, '', 1, '', '', 'MAGE'
    elseif (index == 4) then
        return 'Fake' .. index, '', 1, '', '', 'WARLOCK'
    elseif (index == 5) then
        return 'Fake' .. index, '', 1, '', '', 'PALADIN'

    elseif (index == 6) then
        return 'Fake' .. index, '', 2, '', '', 'WARRIOR'
    elseif (index == 7) then
        return 'Fake' .. index, '', 2, '', '', 'ROGUE'
    elseif (index == 8) then
        return 'Fake' .. index, '', 2, '', '', 'MAGE'
    elseif (index == 9) then
        return 'Fake' .. index, '', 2, '', '', 'WARLOCK'
    elseif (index == 10) then
        return 'Fake' .. index, '', 2, '', '', 'PALADIN'

    elseif (index == 11) then
        return 'Fake' .. index, '', 3, '', '', 'WARRIOR'
    elseif (index == 12) then
        return 'Fake' .. index, '', 3, '', '', 'ROGUE'
    elseif (index == 13) then
        return 'Fake' .. index, '', 3, '', '', 'MAGE'
    elseif (index == 14) then
        return 'Fake' .. index, '', 3, '', '', 'PRIEST'
    elseif (index == 15) then
        return 'Fake' .. index, '', 3, '', '', 'PALADIN'

    elseif (index == 16) then
        return 'Fake' .. index, '', 4, '', '', 'WARRIOR'
    elseif (index == 17) then
        return 'Fake' .. index, '', 4, '', '', 'ROGUE'
    elseif (index == 18) then
        return 'Fake' .. index, '', 4, '', '', 'MAGE'
    elseif (index == 19) then
        return 'Fake' .. index, '', 4, '', '', 'PRIEST'
    elseif (index == 20) then
        return 'Fake' .. index, '', 4, '', '', 'PALADIN'

    elseif (index == 21) then
        return 'Fake' .. index, '', 5, '', '', 'WARRIOR'
    elseif (index == 22) then
        return 'Fake' .. index, '', 5, '', '', 'ROGUE'
    elseif (index == 23) then
        return oliPlayerName, '', 5, '', '', 'MAGE'
    elseif (index == 24) then
        return 'Fake' .. index, '', 5, '', '', 'PRIEST'
    elseif (index == 25) then
        return 'Fake' .. index, '', 5, '', '', 'DRUID'

    elseif (index == 26) then
        return 'Fake' .. index, '', 6, '', '', 'WARRIOR'
    elseif (index == 27) then
        return 'Fake' .. index, '', 6, '', '', 'ROGUE'
    elseif (index == 28) then
        return 'Fake' .. index, '', 6, '', '', 'MAGE'
    elseif (index == 29) then
        return 'Fake' .. index, '', 6, '', '', 'PRIEST'
    elseif (index == 30) then
        return 'Fake' .. index, '', 6, '', '', 'DRUID'

    elseif (index == 31) then
        return 'Fake' .. index, '', 7, '', '', 'WARRIOR'
    elseif (index == 32) then
        return 'Fake' .. index, '', 7, '', '', 'ROGUE'
    elseif (index == 33) then
        return 'Fake' .. index, '', 7, '', '', 'WARLOCK'
    elseif (index == 34) then
        return 'Fake' .. index, '', 7, '', '', 'PRIEST'
    elseif (index == 35) then
        return 'Fake' .. index, '', 7, '', '', 'HUNTER'

    elseif (index == 36) then
        return 'Fake' .. index, '', 8, '', '', 'WARRIOR'
    elseif (index == 37) then
        return 'Fake' .. index, '', 8, '', '', 'ROGUE'
    elseif (index == 38) then
        return 'Fake' .. index, '', 8, '', '', 'WARLOCK'
    elseif (index == 39) then
        return 'Fake' .. index, '', 8, '', '', 'PRIEST'
    elseif (index == 40) then
        return 'Fake' .. index, '', 8, '', '', 'HUNTER'
    end
end

local function oliRaidInfo(debug)
    local rosterFunction = debug and oliFakeRaidRosterInfo or GetRaidRosterInfo
    for i = 1, MAX_RAID_MEMBERS do
        local name, _, group, _, _, class = rosterFunction(i);

        if (class == "ROGUE" or class == "WARRIOR") then
            if dotRes[group][1][1] == "Empty" or dotRes[group][1][1] == name then
                dotRes[group][1] = { name, class }
            elseif dotRes[group][2][1] == "Empty" or dotRes[group][2][1] == name then
                dotRes[group][2] = { name, class }
            elseif dotRes[group][3][1] == "Empty" or dotRes[group][3][1] == name then
                dotRes[group][3] = { name, class }
            elseif dotRes[group][4][1] == "Empty" or dotRes[group][4][1] == name then
                dotRes[group][4] = { name, class }
            else
                dotRes[group][5] = { name, class }
            end
        elseif (class == "MAGE" or class == "WARLOCK" or class == "HUNTER") then
            if dotRes[group][3][1] == "Empty" or dotRes[group][3][1] == name then
                dotRes[group][3] = { name, class }
            elseif dotRes[group][4][1] == "Empty" or dotRes[group][4][1] == name then
                dotRes[group][4] = { name, class }
            elseif dotRes[group][5][1] == "Empty" or dotRes[group][5][1] == name then
                dotRes[group][5] = { name, class }
            elseif dotRes[group][2][1] == "Empty" or dotRes[group][2][1] == name then
                dotRes[group][2] = { name, class }
            else
                dotRes[group][1] = { name, class }
            end
        elseif (class == "PRIEST" or class == "PALADIN" or class == "DRUID" or class == "SHAMAN") then
            if dotRes[group][5][1] == "Empty" or dotRes[group][5][1] == name then
                dotRes[group][5] = { name, class }
            elseif dotRes[group][4][1] == "Empty" or dotRes[group][4][1] == name then
                dotRes[group][4] = { name, class }
            elseif dotRes[group][3][1] == "Empty" or dotRes[group][3][1] == name then
                dotRes[group][3] = { name, class }
            elseif dotRes[group][2][1] == "Empty" or dotRes[group][2][1] == name then
                dotRes[group][2] = { name, class }
            else
                dotRes[group][1] = { name, class }
            end
        end
    end
end



local function oliWipe()
    for i = 1, 8 do
        for j = 1, 5 do
            for k = 1, 2 do
                dotRes[i][j][k] = "Empty"
            end
        end
    end
end

local function oliFill(debug)
    oliWipe()
    oliRaidInfo(debug)
    for i = 1, 8 do
        for j = 1, 5 do
            local x = ((i - 1) * 5) + j
            newDot(_G["Dot_" .. x], _G["Tooltip_" .. x], _G["Texture_" .. x], dotRes[i][j][1], dotRes[i][j][2])
        end
    end
end

local function oliSetMarks()
    for i = 1, MAX_RAID_MEMBERS do
        local name, _, _, _, _, _ = GetRaidRosterInfo(i);
        if (name) then
            SetRaidTarget(name, 0)
        end
    end
    for i = 0, 7 do
        if (dotRes[i + 1][1][1] ~= 'Empty') then
            SetRaidTarget(dotRes[i + 1][1][1], 8 - i)
        elseif (dotRes[i + 1][2][1] ~= 'Empty') then
            SetRaidTarget(dotRes[i + 1][2][1], 8 - i)
        elseif (dotRes[i + 1][3][1] ~= 'Empty') then
            SetRaidTarget(dotRes[i + 1][3][1], 8 - i)
        elseif (dotRes[i + 1][4][1] ~= 'Empty') then
            SetRaidTarget(dotRes[i + 1][4][1], 8 - i)
        elseif (dotRes[i + 1][5][1] ~= 'Empty') then
            SetRaidTarget(dotRes[i + 1][5][1], 8 - i)
        end
    end
end

local Olivier_Marks = CreateFrame("Button", "Olivier_Marks", Olivier_Frame)
Olivier_Marks:SetPoint("CENTER", Olivier_Frame, "CENTER", 4, 10)
Olivier_Marks:SetHeight(64)
Olivier_Marks:SetWidth(64)
Olivier_Marks:SetHighlightTexture("Interface\\AddOns\\OlivierCthun\\Media\\oliMarks.tga", "MOD")
--marks:SetPushedTexture("Interface\\AddOns\\OlivierCthun\\Media\\oliMarks.tga", "MOD")
Olivier_Marks:SetScript("OnLoad",
        function()
            marks:RegisterForClicks("AnyUp")
        end
)
Olivier_Marks:SetScript("OnClick",
        function()
            oliSetMarks()
        end
)

SLASH_CTHUN1 = "/cthun";
local function HandleSlashCommands(arg)
    if (arg == "test") then
        Olivier_Frame:Show();
        oliFill('debug')
    elseif (arg == "" or arg == nil) then
        Olivier_Frame:Show();
        oliFill()
    else
        print("|cffffff00Use \'/cthun test\' to show fake raid");
    end
end

SlashCmdList.CTHUN = HandleSlashCommands;
